package com.biganto.visual.roompark.base

import android.view.ViewGroup
import androidx.appcompat.widget.Toolbar
import androidx.coordinatorlayout.widget.CoordinatorLayout
import com.google.android.material.appbar.AppBarLayout
import com.google.android.material.appbar.CollapsingToolbarLayout
import com.google.android.material.bottomnavigation.BottomNavigationView

/**
 * Created by Vladislav Bogdashkin on 26.09.2019.
 */

interface ISupportActionBar{
    val topAppBar : Toolbar
    fun displayBackButton(show:Boolean)
    fun hideAll()
    fun showAll()
}

interface ICollapsingToolBar : ISupportActionBar{
    val appBar : AppBarLayout
    val coordinatorLayout: CoordinatorLayout
    val collapsingToolbarLayout : CollapsingToolbarLayout
    fun appBarScrollable(allow:Boolean)
}

interface IConductorActivity{
    val conductorContainer: ViewGroup
}

interface IBottomNavigation{
    val bottomNavigation : BottomNavigationView
    fun hide()
    fun show()
}
