package com.biganto.visual.roompark.di.dagger

import com.biganto.visual.roompark.data.data_provider.AlbumsContractModule
import com.biganto.visual.roompark.data.data_provider.AuthContractModule
import com.biganto.visual.roompark.data.data_provider.EstateRepository
import com.biganto.visual.roompark.data.data_provider.FeedsContractModule
import com.biganto.visual.roompark.data.local.LocalStorage
import com.biganto.visual.roompark.data.repository.api.IRoomParkApi
import com.biganto.visual.roompark.data.repository.api.retrofit.RetrofitRepository
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.db.IDb
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import com.biganto.visual.roompark.data.repository.db.requrey.RequeryRepository
import com.biganto.visual.roompark.domain.contract.AuthContract
import com.biganto.visual.roompark.domain.contract.DealContract
import com.biganto.visual.roompark.domain.contract.DevProgressContract
import com.biganto.visual.roompark.domain.contract.FeedsContract
import dagger.Binds
import dagger.Component
import dagger.Module
import javax.inject.Singleton

@Component
interface DataComponent{

}

@Module(includes = [DataModule::class, RetrofitModule::class, DbModule::class,LocalStorage::class])
abstract class ContractRepositoryModule {

    @Binds
    abstract fun provideAuth(contract:AuthContractModule):AuthContract

    @Binds
    abstract fun provideFeedsContract(impl: FeedsContractModule): FeedsContract

    @Binds
    abstract fun provideDevProgressContract(impl: AlbumsContractModule): DevProgressContract

    @Binds
    abstract fun provideEstateContract(impl: EstateRepository): DealContract
}



@Module
abstract class DataModule {


//    @Singleton
//    @Binds
//    abstract fun provideAuthContract(contract: AuthContractModule) : AuthContract

//    @Binds
//    abstract fun provideModule(m:RetrofitModule) : RetrofitModule

//    @Binds
//    abstract fun provideRpRetrofit(retrofit:Retrofit) : Retrofit
//

    @Singleton
    @Binds
    abstract fun provideRoomParkApi(api: RetrofitRepository) : IRoomParkApi


//    @Binds
//    abstract fun provideStore(store: KotlinReactiveEntityStore<Persistable>) : KotlinReactiveEntityStore<Persistable>

    @Singleton
    @Binds
    abstract fun provideDb(db: RequeryRepository) : IDb



//    @Singleton
//    @Binds
//    abstract fun provideLocalStorage(local: UserHolder) : ILocalStore



/*
    @Provides
    @Singleton
    fun provieApi(@Named("bigantoApi") retorfit:Retrofit): IApi {
        return RetrofitRepository(retorfit)
    }


    @Provides
    @Singleton
    fun provieRoomParkApi(@Named("roomParkApi") retorfit:Retrofit): IRoomParkApi {
        return RoomParkRetrofitRepository(retorfit)
    }


    @Provides
    @Singleton
    fun provideDb(context:Application): IDb {
        return RequeryRepository(getRequeryDataStore(context))
    }

    @Provides
    @Singleton
    fun provideFileModule(context:Application): FilesModule {
        return FilesModule(context)
    }

    @Provides
    @Singleton
    fun providesNetworkListener(context:Application): INetworkMonitor {
        return LiveNetworkMonitor(context)
    }



    @Provides
    @Singleton
    fun getRequeryDataStore(context:Application): KotlinReactiveEntityStore<Persistable> {
        Timber.d("Kotlin store creating..")
        val source = DatabaseSource(context, Models.DEFAULT, "BigantoPerfect", DATABASE_VERSION)

        source.setLoggingEnabled(false)
//        if (  BuildConfig.DEBUG) {
//            // use this in development mode to drop and recreate the tables on every upgrade
//            source.setTableCreationMode(TableCreationMode.DROP_CREATE)
//        }

        val store = KotlinEntityDataStore<Persistable>(source.configuration)
        Timber.d("Kotlin store %s",source)
        return KotlinReactiveEntityStore(store)
//        // override onUpgrade to handle migrating to a new version
//        val configuration = source.configuration
//        return ReactiveSupport.toReactiveStore(
//                EntityDataStore<Persistable>(configuration))
    }

    */
}