package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.CommonInfoModel
import com.biganto.visual.roompark.domain.model.EstateModel
import com.biganto.visual.roompark.domain.model.PlanModel
import com.biganto.visual.roompark.domain.use_case.EstateUseCase
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class FavoritesInteractor @Inject constructor(
    private val estateUseCase: EstateUseCase
) {

    fun getFavoritesForCurrentUser() =
        estateUseCase.fetchFavorites()
//        Single.just(parkingEstateSample )


    companion object {

        val parkingEstateSample = arrayListOf(
            EstateModel(

                id = 2273,
                type = "parking",
                number = "П1.021",
                commonInfo = CommonInfoModel(
                    building = 1,
                    section_begin = 1,
                    floor = -1,
                    floor_max = 13,
                    area = 13.25f,
                    area_living = 0.00f,
                    kind = null,
                    decoration = "Без отделки, свободная планировка",
                    ceiling = null,
                    windows_face = null,
                    direction = null,
                    price_meter = null,
                    price = 1170025,
                    discount = null,
                    discount_amount = 970025,
                    rooms = null,
                    dependent = false
                ),
                planPNG = null,
                planJPG = null,
                albumId = 10,
                multitourId = null,
                url = null
            ),
            EstateModel(
                id = 1905,
                type = "storage",
                number = "104.23",
                commonInfo = CommonInfoModel(
                    building = 1,
                    section_begin = 4,
                    floor = -1,
                    floor_max = 13,
                    area = 2.78f,
                    area_living = 0.00f,
                    kind = null,
                    decoration = "beez otdelki",
                    ceiling = null,
                    windows_face = null,
                    direction = null,
                    price_meter = 69676,
                    price = 193700,
                    discount = null,
                    discount_amount = null,
                    dependent = false,
                    rooms = null
                ),
                planPNG = null,
                planJPG = null,
                albumId = 10,
                multitourId = null,
                url = null
            ),
            EstateModel(
                id = 1774,
                type = "flat",
                number = "417",
                commonInfo = CommonInfoModel(
                    building = 1,
                    section_begin = 6,
                    floor = 5,
                    floor_max = 20,
                    area = 40.00f,
                    area_living = 16.30f,
                    kind = "1к-2",
                    decoration = "Без отделки, свободная планировкаотделки",
                    ceiling = 2.95f,
                    windows_face = "Двор",
                    direction = "восток",
                    price_meter = 142808,
                    price = 5712300,
                    discount = 5.00f,
                    discount_amount = 5426685,
                    dependent = null,
                    rooms = 1
                ),
                planPNG = PlanModel(
                    url = "https://room-park.ru/assets/estates/plan_png/00/00/06/1774-a0e8d6.png",
                    width = 281,
                    height = 292
                ),
                planJPG = PlanModel(
                    url = "https://room-park.ru/assets/estates/plan_jpg/00/00/06/1774-6b330b.jpeg",
                    width = 693,
                    height = 720
                ),
                albumId = 10,
                url = null,
                multitourId = 5790
//                ,explications = arrayListOf<ExplicationListModel>(
//                    ExplicationListModel(
//                        planId = 0,
//                        items = arrayListOf(
//                            ExplicationModel(
//                                living = true,
//                                area = 16.30f,
//                                title = "Спальня"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 11.40f,
//                                title = "Кухня"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 1.90f,
//                                title = "Прихожая"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 5.20f,
//                                title = "Коридор"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 1.70f,
//                                title = "Лоджия"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 3.50f,
//                                title = "Санузел"
//                            )
//                        )
//                    ), ExplicationListModel(
//                        planId = 1,
//                        items = arrayListOf(
//                            ExplicationModel(
//                                living = true,
//                                area = 16.30f,
//                                title = "Спальня"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 11.40f,
//                                title = "Кухня"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 5.20f,
//                                title = "Коридор"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 1.90f,
//                                title = "Прихожая"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 3.50f,
//                                title = "Санузел"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 1.70f,
//                                title = "Лоджия"
//                            )
//                        )
//                    ), ExplicationListModel(
//                        planId = 2,
//                        items = arrayListOf(
//                            ExplicationModel(
//                                living = false,
//                                area = 1.00f,
//                                title = "Кухня-гостиная"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 2.00f,
//                                title = "Коридор"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 3.00f,
//                                title = "Прихожая"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 4.00f,
//                                title = "Санузел"
//                            ),
//                            ExplicationModel(
//                                living = false,
//                                area = 5.00f,
//                                title = "Лоджия"
//                            )
//                        )
//                    )
//                )
            )
        )

    }
}






























