package com.biganto.visual.roompark.domain.interactor

import com.biganto.visual.roompark.domain.model.CachedDataModel
import com.biganto.visual.roompark.domain.model.PushSwitchModel
import com.biganto.visual.roompark.domain.model.SettingsModel
import com.biganto.visual.roompark.domain.use_case.AuthUseCase
import io.reactivex.Observable
import io.reactivex.schedulers.Schedulers
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 09.10.2019.
 */

class SettingsInteractor @Inject constructor(
    private val auth: AuthUseCase

){

    fun fetchSettings(): Observable<SettingsModel> = Observable.just(sampleSettings)

    fun signOut() = auth.signOut().subscribeOn(Schedulers.io())

    companion object{

        val sampleSettings = SettingsModel(
            arrayListOf(

                PushSwitchModel("Новости",1,"zsldfj",true),
                PushSwitchModel("Блог",2,"zsldfj",false),
                PushSwitchModel("Ход Строительства Дом №1",3,"zsldfj",true),
                PushSwitchModel("Сделка кв №451",4,"zsldfj",true),
                PushSwitchModel("Сделка кв №452",5,"zsldfj",true)
            ),
            arrayListOf(
                CachedDataModel("Скачать карточки моих\n" +
                        "квартир из избранного\n" +
                        "и сделок",8415456588L,900),
                CachedDataModel("Скачать виртуальные туры \n" +
                        "моих квартир из избранного\n" +
                        "и сделок ",656853321588L,999)

            ),
            arrayListOf(
                CachedDataModel("Всего скачано",2834264238L,1),
                CachedDataModel("Карточки квартир",6434268L,2),
                CachedDataModel("Виртуальные туры",1782234268L,3),
                CachedDataModel("Новости и заметки",4323438L,4),
                CachedDataModel("Фотографии",164444L,5)
            )
        )
    }
}
