package com.biganto.visual.roompark.domain.use_case

import com.biganto.visual.roompark.domain.contract.DealContract
import javax.inject.Inject

/**
 * Created by Vladislav Bogdashkin on 24.09.2019.
 */

class EstateUseCase @Inject constructor(
    private val contract: DealContract
) {

    fun fetchFavorites() = contract.getFavorites()

    fun getEstate(estateId: Int) = contract.getEstate(estateId)

    fun getEstatePlanPresets(estateId: Int) =
        contract.getPlanTypes(estateId)


    fun getPlan(estateId: Int, planId: Int) =
        contract.getEmptyPlan(estateId, planId)

    fun getPlan(
        estateId: Int
        , planId: Int
        , furniture: Boolean?
        , sizes: Boolean?
        , walls: Boolean?
        , electric: Boolean?
    ) = contract.getPlan(
        estateId
        , planId
        , furniture
        , sizes
        , walls
        , electric
    )

}