package com.biganto.visual.roompark.presentation.screen.deals

import com.biganto.visual.roompark.conductor.BigantoBaseContract
import com.biganto.visual.roompark.domain.model.DealModel
import com.biganto.visual.roompark.domain.model.StatusModel

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */

interface DealsScreen : BigantoBaseContract<DealsScreenViewState> {
}


data class DealPreviewModel(
    val id:String,
    val type:String,
    val name:String,
    val building:Int?,
    val section:Int?,
    val floor:Int?,
    val area: Float?,
    val statusNo : Int,
    val dealSum : Int,
    val dealPayout : Int,
    val dealToPay : Int,
    val dealTourIds : List<Int?>?,
    val isViewed: Boolean = true,
    val statusList : List<StatusModel>
){
    constructor(data:Pair<DealModel,List<StatusModel>>) : this(
        data.first.id,
        data.first.estate.type,
        data.first.estate.number,
        data.first.estate.commonInfo?.building,
        data.first.estate.commonInfo?.section_begin,
        data.first.estate.commonInfo?.floor,
        data.first.estate.commonInfo?.area,
        data.first.statusId,
        data.first.opportunitySum,
        data.first.paymentSum,
        data.first.amount_pay_sum,
        arrayListOf<Int?>(data.first.estate.multitourId),
        false,
        data.second
    )
}