package com.biganto.visual.roompark.presentation.screen.to_flat

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.TourModel
import com.biganto.visual.roompark.util.monades.ExceptionString

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class FindFlatScreenViewState : BigantoBaseViewState() {
    class Idle : FindFlatScreenViewState()
    class RequstFlatProgress : FindFlatScreenViewState()
    class TourFounded(val items:List<TourModel>) : FindFlatScreenViewState()
    class StartTour(val tourId:String) : FindFlatScreenViewState()
    class FlatNotFound() : FindFlatScreenViewState()
    class SomeError(val exception: ExceptionString) : FindFlatScreenViewState()
}